package com.lightinit.hsdataplatform.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class RequirementExample  extends BaseExample{
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public RequirementExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIsNull() {
            addCriterion("platform_type is null");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIsNotNull() {
            addCriterion("platform_type is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeEqualTo(String value) {
            addCriterion("platform_type =", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotEqualTo(String value) {
            addCriterion("platform_type <>", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeGreaterThan(String value) {
            addCriterion("platform_type >", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeGreaterThanOrEqualTo(String value) {
            addCriterion("platform_type >=", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeLessThan(String value) {
            addCriterion("platform_type <", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeLessThanOrEqualTo(String value) {
            addCriterion("platform_type <=", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeLike(String value) {
            addCriterion("platform_type like", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotLike(String value) {
            addCriterion("platform_type not like", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIn(List<String> values) {
            addCriterion("platform_type in", values, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotIn(List<String> values) {
            addCriterion("platform_type not in", values, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeBetween(String value1, String value2) {
            addCriterion("platform_type between", value1, value2, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotBetween(String value1, String value2) {
            addCriterion("platform_type not between", value1, value2, "platformType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeIsNull() {
            addCriterion("rqrmnt_type is null");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeIsNotNull() {
            addCriterion("rqrmnt_type is not null");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeEqualTo(String value) {
            addCriterion("rqrmnt_type =", value, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeNotEqualTo(String value) {
            addCriterion("rqrmnt_type <>", value, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeGreaterThan(String value) {
            addCriterion("rqrmnt_type >", value, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeGreaterThanOrEqualTo(String value) {
            addCriterion("rqrmnt_type >=", value, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeLessThan(String value) {
            addCriterion("rqrmnt_type <", value, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeLessThanOrEqualTo(String value) {
            addCriterion("rqrmnt_type <=", value, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeLike(String value) {
            addCriterion("rqrmnt_type like", value, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeNotLike(String value) {
            addCriterion("rqrmnt_type not like", value, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeIn(List<String> values) {
            addCriterion("rqrmnt_type in", values, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeNotIn(List<String> values) {
            addCriterion("rqrmnt_type not in", values, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeBetween(String value1, String value2) {
            addCriterion("rqrmnt_type between", value1, value2, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntTypeNotBetween(String value1, String value2) {
            addCriterion("rqrmnt_type not between", value1, value2, "rqrmntType");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateIsNull() {
            addCriterion("rqrmnt_state is null");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateIsNotNull() {
            addCriterion("rqrmnt_state is not null");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateEqualTo(String value) {
            addCriterion("rqrmnt_state =", value, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateNotEqualTo(String value) {
            addCriterion("rqrmnt_state <>", value, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateGreaterThan(String value) {
            addCriterion("rqrmnt_state >", value, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateGreaterThanOrEqualTo(String value) {
            addCriterion("rqrmnt_state >=", value, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateLessThan(String value) {
            addCriterion("rqrmnt_state <", value, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateLessThanOrEqualTo(String value) {
            addCriterion("rqrmnt_state <=", value, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateLike(String value) {
            addCriterion("rqrmnt_state like", value, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateNotLike(String value) {
            addCriterion("rqrmnt_state not like", value, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateIn(List<String> values) {
            addCriterion("rqrmnt_state in", values, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateNotIn(List<String> values) {
            addCriterion("rqrmnt_state not in", values, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateBetween(String value1, String value2) {
            addCriterion("rqrmnt_state between", value1, value2, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntStateNotBetween(String value1, String value2) {
            addCriterion("rqrmnt_state not between", value1, value2, "rqrmntState");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceIsNull() {
            addCriterion("rqrmnt_source is null");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceIsNotNull() {
            addCriterion("rqrmnt_source is not null");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceEqualTo(String value) {
            addCriterion("rqrmnt_source =", value, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceNotEqualTo(String value) {
            addCriterion("rqrmnt_source <>", value, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceGreaterThan(String value) {
            addCriterion("rqrmnt_source >", value, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceGreaterThanOrEqualTo(String value) {
            addCriterion("rqrmnt_source >=", value, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceLessThan(String value) {
            addCriterion("rqrmnt_source <", value, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceLessThanOrEqualTo(String value) {
            addCriterion("rqrmnt_source <=", value, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceLike(String value) {
            addCriterion("rqrmnt_source like", value, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceNotLike(String value) {
            addCriterion("rqrmnt_source not like", value, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceIn(List<String> values) {
            addCriterion("rqrmnt_source in", values, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceNotIn(List<String> values) {
            addCriterion("rqrmnt_source not in", values, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceBetween(String value1, String value2) {
            addCriterion("rqrmnt_source between", value1, value2, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andRqrmntSourceNotBetween(String value1, String value2) {
            addCriterion("rqrmnt_source not between", value1, value2, "rqrmntSource");
            return (Criteria) this;
        }

        public Criteria andPublishByIsNull() {
            addCriterion("publish_by is null");
            return (Criteria) this;
        }

        public Criteria andPublishByIsNotNull() {
            addCriterion("publish_by is not null");
            return (Criteria) this;
        }

        public Criteria andPublishByEqualTo(Long value) {
            addCriterion("publish_by =", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByNotEqualTo(Long value) {
            addCriterion("publish_by <>", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByGreaterThan(Long value) {
            addCriterion("publish_by >", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByGreaterThanOrEqualTo(Long value) {
            addCriterion("publish_by >=", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByLessThan(Long value) {
            addCriterion("publish_by <", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByLessThanOrEqualTo(Long value) {
            addCriterion("publish_by <=", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByIn(List<Long> values) {
            addCriterion("publish_by in", values, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByNotIn(List<Long> values) {
            addCriterion("publish_by not in", values, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByBetween(Long value1, Long value2) {
            addCriterion("publish_by between", value1, value2, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByNotBetween(Long value1, Long value2) {
            addCriterion("publish_by not between", value1, value2, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishAtIsNull() {
            addCriterion("publish_at is null");
            return (Criteria) this;
        }

        public Criteria andPublishAtIsNotNull() {
            addCriterion("publish_at is not null");
            return (Criteria) this;
        }

        public Criteria andPublishAtEqualTo(Date value) {
            addCriterion("publish_at =", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtNotEqualTo(Date value) {
            addCriterion("publish_at <>", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtGreaterThan(Date value) {
            addCriterion("publish_at >", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtGreaterThanOrEqualTo(Date value) {
            addCriterion("publish_at >=", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtLessThan(Date value) {
            addCriterion("publish_at <", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtLessThanOrEqualTo(Date value) {
            addCriterion("publish_at <=", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtIn(List<Date> values) {
            addCriterion("publish_at in", values, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtNotIn(List<Date> values) {
            addCriterion("publish_at not in", values, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtBetween(Date value1, Date value2) {
            addCriterion("publish_at between", value1, value2, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtNotBetween(Date value1, Date value2) {
            addCriterion("publish_at not between", value1, value2, "publishAt");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameIsNull() {
            addCriterion("rqrmnt_name is null");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameIsNotNull() {
            addCriterion("rqrmnt_name is not null");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameEqualTo(String value) {
            addCriterion("rqrmnt_name =", value, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameNotEqualTo(String value) {
            addCriterion("rqrmnt_name <>", value, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameGreaterThan(String value) {
            addCriterion("rqrmnt_name >", value, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameGreaterThanOrEqualTo(String value) {
            addCriterion("rqrmnt_name >=", value, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameLessThan(String value) {
            addCriterion("rqrmnt_name <", value, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameLessThanOrEqualTo(String value) {
            addCriterion("rqrmnt_name <=", value, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameLike(String value) {
            addCriterion("rqrmnt_name like", value, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameNotLike(String value) {
            addCriterion("rqrmnt_name not like", value, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameIn(List<String> values) {
            addCriterion("rqrmnt_name in", values, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameNotIn(List<String> values) {
            addCriterion("rqrmnt_name not in", values, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameBetween(String value1, String value2) {
            addCriterion("rqrmnt_name between", value1, value2, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntNameNotBetween(String value1, String value2) {
            addCriterion("rqrmnt_name not between", value1, value2, "rqrmntName");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryIsNull() {
            addCriterion("rqrmnt_summary is null");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryIsNotNull() {
            addCriterion("rqrmnt_summary is not null");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryEqualTo(String value) {
            addCriterion("rqrmnt_summary =", value, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryNotEqualTo(String value) {
            addCriterion("rqrmnt_summary <>", value, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryGreaterThan(String value) {
            addCriterion("rqrmnt_summary >", value, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryGreaterThanOrEqualTo(String value) {
            addCriterion("rqrmnt_summary >=", value, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryLessThan(String value) {
            addCriterion("rqrmnt_summary <", value, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryLessThanOrEqualTo(String value) {
            addCriterion("rqrmnt_summary <=", value, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryLike(String value) {
            addCriterion("rqrmnt_summary like", value, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryNotLike(String value) {
            addCriterion("rqrmnt_summary not like", value, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryIn(List<String> values) {
            addCriterion("rqrmnt_summary in", values, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryNotIn(List<String> values) {
            addCriterion("rqrmnt_summary not in", values, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryBetween(String value1, String value2) {
            addCriterion("rqrmnt_summary between", value1, value2, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andRqrmntSummaryNotBetween(String value1, String value2) {
            addCriterion("rqrmnt_summary not between", value1, value2, "rqrmntSummary");
            return (Criteria) this;
        }

        public Criteria andAuditedByIsNull() {
            addCriterion("audited_by is null");
            return (Criteria) this;
        }

        public Criteria andAuditedByIsNotNull() {
            addCriterion("audited_by is not null");
            return (Criteria) this;
        }

        public Criteria andAuditedByEqualTo(Long value) {
            addCriterion("audited_by =", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotEqualTo(Long value) {
            addCriterion("audited_by <>", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByGreaterThan(Long value) {
            addCriterion("audited_by >", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByGreaterThanOrEqualTo(Long value) {
            addCriterion("audited_by >=", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByLessThan(Long value) {
            addCriterion("audited_by <", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByLessThanOrEqualTo(Long value) {
            addCriterion("audited_by <=", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByIn(List<Long> values) {
            addCriterion("audited_by in", values, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotIn(List<Long> values) {
            addCriterion("audited_by not in", values, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByBetween(Long value1, Long value2) {
            addCriterion("audited_by between", value1, value2, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotBetween(Long value1, Long value2) {
            addCriterion("audited_by not between", value1, value2, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIsNull() {
            addCriterion("audited_at is null");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIsNotNull() {
            addCriterion("audited_at is not null");
            return (Criteria) this;
        }

        public Criteria andAuditedAtEqualTo(Date value) {
            addCriterion("audited_at =", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotEqualTo(Date value) {
            addCriterion("audited_at <>", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtGreaterThan(Date value) {
            addCriterion("audited_at >", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("audited_at >=", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtLessThan(Date value) {
            addCriterion("audited_at <", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtLessThanOrEqualTo(Date value) {
            addCriterion("audited_at <=", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIn(List<Date> values) {
            addCriterion("audited_at in", values, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotIn(List<Date> values) {
            addCriterion("audited_at not in", values, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtBetween(Date value1, Date value2) {
            addCriterion("audited_at between", value1, value2, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotBetween(Date value1, Date value2) {
            addCriterion("audited_at not between", value1, value2, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditResultIsNull() {
            addCriterion("audit_result is null");
            return (Criteria) this;
        }

        public Criteria andAuditResultIsNotNull() {
            addCriterion("audit_result is not null");
            return (Criteria) this;
        }

        public Criteria andAuditResultEqualTo(String value) {
            addCriterion("audit_result =", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotEqualTo(String value) {
            addCriterion("audit_result <>", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultGreaterThan(String value) {
            addCriterion("audit_result >", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultGreaterThanOrEqualTo(String value) {
            addCriterion("audit_result >=", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLessThan(String value) {
            addCriterion("audit_result <", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLessThanOrEqualTo(String value) {
            addCriterion("audit_result <=", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLike(String value) {
            addCriterion("audit_result like", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotLike(String value) {
            addCriterion("audit_result not like", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultIn(List<String> values) {
            addCriterion("audit_result in", values, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotIn(List<String> values) {
            addCriterion("audit_result not in", values, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultBetween(String value1, String value2) {
            addCriterion("audit_result between", value1, value2, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotBetween(String value1, String value2) {
            addCriterion("audit_result not between", value1, value2, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIsNull() {
            addCriterion("audit_opinion is null");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIsNotNull() {
            addCriterion("audit_opinion is not null");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionEqualTo(String value) {
            addCriterion("audit_opinion =", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotEqualTo(String value) {
            addCriterion("audit_opinion <>", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionGreaterThan(String value) {
            addCriterion("audit_opinion >", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionGreaterThanOrEqualTo(String value) {
            addCriterion("audit_opinion >=", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLessThan(String value) {
            addCriterion("audit_opinion <", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLessThanOrEqualTo(String value) {
            addCriterion("audit_opinion <=", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLike(String value) {
            addCriterion("audit_opinion like", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotLike(String value) {
            addCriterion("audit_opinion not like", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIn(List<String> values) {
            addCriterion("audit_opinion in", values, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotIn(List<String> values) {
            addCriterion("audit_opinion not in", values, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionBetween(String value1, String value2) {
            addCriterion("audit_opinion between", value1, value2, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotBetween(String value1, String value2) {
            addCriterion("audit_opinion not between", value1, value2, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andViewTimesIsNull() {
            addCriterion("view_times is null");
            return (Criteria) this;
        }

        public Criteria andViewTimesIsNotNull() {
            addCriterion("view_times is not null");
            return (Criteria) this;
        }

        public Criteria andViewTimesEqualTo(Long value) {
            addCriterion("view_times =", value, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesNotEqualTo(Long value) {
            addCriterion("view_times <>", value, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesGreaterThan(Long value) {
            addCriterion("view_times >", value, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesGreaterThanOrEqualTo(Long value) {
            addCriterion("view_times >=", value, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesLessThan(Long value) {
            addCriterion("view_times <", value, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesLessThanOrEqualTo(Long value) {
            addCriterion("view_times <=", value, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesIn(List<Long> values) {
            addCriterion("view_times in", values, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesNotIn(List<Long> values) {
            addCriterion("view_times not in", values, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesBetween(Long value1, Long value2) {
            addCriterion("view_times between", value1, value2, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andViewTimesNotBetween(Long value1, Long value2) {
            addCriterion("view_times not between", value1, value2, "viewTimes");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}